/*
 * d_delkey.c
 *
 * $Source: /source/MASTER/garden/datlib/RCS/d_delkey.c,v $
 * $Date: 91/11/02 23:31:20 $
 * $Author: klee $
 * $Locker:  $
 *
 * This file is part of the dat library.
 *
 * $Log:	d_delkey.c,v $
 * Revision 1.4  91/11/02  23:31:20  klee
 * updated for const declarations
 * 
 * Revision 1.3  90/12/08  03:05:31  kaboom
 * Placed under RCS, moved copyright notice to copyright.h.
 * 
 * Revision 1.2  89/01/13  02:43:46  jwang
 * Add M.I.T. copyright message.
 * 
 * Revision 1.1  85/06/29  00:09:17  musicus
 * Initial revision
 * 
 *
 * #include	<dat.h>
 * 
 * d_delkey(d,key)
 * 
 * 	deletes the key from the dat file header
 *	returns NULL if succeeds, -1 if can't find the key
 *	if succeeds, sets _DB_WRHDR flag to indicate header modified.
 */

static char rcsid[] = "$Header: /source/MASTER/garden/datlib/RCS/d_delkey.c,v 1.4 91/11/02 23:31:20 klee Exp $" ;

#include "copyright.h"
#include <stdio.h>
#include "dat.h"


int
d_delkey(d,key)
	DATFILE *d;
	const char *key;
{
	struct d_token **plast;
	struct d_token *pnext;
	
	if(d->db_h == (struct d_token *)-1)
		return(-1);
	plast = &(d->db_h);
	while((pnext = *plast) != NULL)
	{
		if(strcmp(pnext->d_key,key)==0)
		{
			free(pnext->d_key);
			free(pnext->d_value);
			*plast = pnext->d_next;
			free(pnext);
			d->db_flag |= _DB_WRHDR;
			return(NULL);
		}
		plast = &(pnext->d_next);
	}
	return(-1);
}
