//
// tclDpweMisc.cc
// 
// random tcl extension
// 
// dpwe@media.mit.edu 1994nov17
//

#include <assert.h>

#include "Sound.h"
extern "C" {
#include "tcl.h"
int Misc_Init(Tcl_Interp *interp);
   /* add the tcl commands defined in this package to the interpreter */
}

#ifdef __sgi
#include <audio.h>

int audioStatusCommand(ClientData clientData, Tcl_Interp *interp, 
		 int argc, char **argv)
{	/* tcl command to read the audio status */
    char rslt[32];
    long pvb[32], pvl = 0;
    int inputSource, inputRate, outputRate, inputCount, outputCount;
    char *inpSrcName = "unknown";

    if(argc > 1) {
	Tcl_AppendResult(interp, "wrong # args; should be \"", 
			 argv[0], " which returns inSrc inRate outRate inCnt outCnt ", NULL);
	return TCL_ERROR;
    }
    pvb[pvl] = AL_INPUT_SOURCE;	pvl += 2;	/* 1 */
    pvb[pvl] = AL_INPUT_RATE;	pvl += 2;	/* 3 */
    pvb[pvl] = AL_OUTPUT_RATE;	pvl += 2;	/* 5 */
    pvb[pvl] = AL_INPUT_COUNT;	pvl += 2;	/* 7 */
    pvb[pvl] = AL_OUTPUT_COUNT;	pvl += 2;	/* 9 */
    ALgetparams(AL_DEFAULT_DEVICE, pvb, pvl);
    inputSource = pvb[1];
    inputRate   = pvb[3];
    outputRate  = pvb[5];
    inputCount  = pvb[7];
    outputCount = pvb[9];
    
    if(inputSource==AL_INPUT_LINE)	inpSrcName = "line";
    if(inputSource==AL_INPUT_MIC)	inpSrcName = "mic";
    if(inputSource==AL_INPUT_DIGITAL)	inpSrcName = "digital";

    sprintf(rslt, "%s %d %d %d %d", inpSrcName, inputRate, outputRate, inputCount, outputCount);

    interp->result = rslt;
    return TCL_OK;
}
#endif /* __sgi */

/* stuff to ring X bell */
#include "tk.h"

int bellCommand(ClientData clientData, Tcl_Interp *interp, 
		int argc, char **argv)
{	/* tcl command to read the audio status */
    Tk_Window main = (Tk_Window) clientData;	/* Main window associated with
						 * interpreter. */
    int bellvol = 50;
    Display *bellDisp = Tk_Display(main);

    if(argc > 2) {
	Tcl_AppendResult(interp, "wrong # args; should be \"",
			 argv[0], " [volPercent]", NULL);
    }
    if(argc == 2)  {
	/* get the bell percent */
	bellvol = atoi(argv[1]);
    }
    if(bellDisp == None)  {
	interp->result = "No X Display present";
	return TCL_ERROR;
    } else {
	XBell(bellDisp, bellvol);
	return TCL_OK;
    }
}

int Misc_Init(Tcl_Interp *interp)
{   /* add the tcl commands defined in this package to the interpreter */
    Tk_Window main = Tk_MainWindow(interp);
#ifdef __sgi
    Tcl_CreateCommand(interp, "audiostatus", audioStatusCommand, 
		      (ClientData) NULL, (void (*)(ClientData)) NULL);
#endif /* __sgi */
    Tcl_CreateCommand(interp, "bell", bellCommand, (ClientData) main,
		      (void (*)(ClientData)) NULL);
    return TCL_OK;
}
